function b = PoissonRHS(h,n,f,ud);
% generate the rhs vector for discrete Finite Difference
% Poisson equation
% input:
%   h : step size 
%   n : number of grid points per direction 
%       (numbering INCLUDES the boundary points)
%   f : values of the rhs at the grid points
%   ud: values of the boundary condition at the boundary points
%       in anti-clockwise numbering from left lower corner 
%
% 12.04.2005 by vita
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


b = [f;ud];

return
% boundary indices
bdry_x_ind = [[1:n]'; n*ones(n-2,1); [n:-1:1]'; ones(n-2,1)];
bdry_y_ind = [ones(n,1); [2:n]'; n*ones(n-1,1); [n-1:-1:2]']; 
      
% pass from double to single indexation
bdry = sub2ind([n,n],bdry_x_ind,bdry_y_ind);
    
b = h*h*reshape(f,[n*n,1]);
b(bdry) = ud;
  
    